function [wn_hat P q_0 q_L q_hat_0 q_hat_L Lambda_0 Lambda_L P_Delta er w_er_in]=find_boundaries_numerical(u_g_hat_L,u_g_hat_0,u_g_L,u_g_0, ...
                            u_l_hat_L,u_l_hat_0,u_l_0,u_l_L, ...
                            epsilon_0,epsilon_hat_0,epsilon_L, ...
                            p_mod_0,p_hat_0,p_mod_L,const, ...
                            mG_hat,mL_hat,wG_hat,wL_hat,...
                            mG,mL,wG,wL,...
                            mG2,mL2,wG2,wL2)
                        
%% INLET
%Forkorte notasjon
kL=const.k_l;
cG=const.c_G;
cL=const.c_L;

p=p_mod_0;
rhoG=(p)/cG^2;
rhoL=(kL+p)/cL^2;
eG=epsilon_0;
eL=(1-epsilon_0);
mG=eG*rhoG;
mL=eL*rhoL;
uG=wG/mG;
uL=wL/mL;
%Regne ut nye variable og deriverte
sigma=0.5*(mG*cG^2+mL*cL^2-kL);
muG=cG^2/2*(1+(sigma+kL)/(sqrt(sigma^2+mG*cG^2*kL)));
muL=cL^2/2*(1+(sigma)/(sqrt(sigma^2+mG*cG^2*kL)));

mG_hat=epsilon_hat_0*(p_hat_0)/cG^2;
mL_hat=(1-epsilon_hat_0)*(kL+p_hat_0)/cL^2;
w_hat=[mG_hat;mL_hat];

%% Virtual Mass - Inlet
cvm=c_virtual_mass(eG,rhoG,rhoL);

rho=mG+mL;
delta= rho^2/rhoL/rhoG*cvm;
c=mG/rho;

u=(wG+wL)/rho;

Adelta=delta*[ zeros(3,4) ; (1-c)*uG*uL -c*uG*uL -(1-c)*uL u];
Mdelta=delta*[ zeros(3,4) ; (1-c)*uG    -c*uL    -(1-c)    1];
A=[0                0               1      -1           ;
   0                0               0       1           ;
   muG-uG^2         muL-uL^2        2*uG    2*(uL-uG)   ;
   eL*muG           eL*muL-uL^2     0       2*uL        ];

A=inv(eye(4)+Mdelta)*(A+Adelta);
w=[mG;mL;wG+wL;wL];

[wn_hat,q_0,q_hat_0,Lambda_0,w_er_in]=numerical_boundaries(A,w,w_hat,2,0,const.dooi,const.output_injection*const.oi,1);

wn_hat=[wn_hat(1)-wn_hat(2) wn_hat(2)];

mG_v=+w_er_in(1)+mG;
mL_v=+w_er_in(2)+mL;

sigma_L=0.5*(mG_v*cG^2+mL_v*cL^2-kL);
P_v=sigma_L+sqrt(sigma_L^2+mG_v*cG^2*kL);

sigma_L=0.5*(mG*cG^2+mL*cL^2-kL);
P_m=sigma_L+sqrt(sigma_L^2+mG*cG^2*kL);

P_Delta=P_m-P_v;

%% OUTLET
%Forkorte notasjon
p=p_mod_L;
eG=epsilon_L;
eL=(1-epsilon_L);
kL=const.k_l;
cG=const.c_G;
cL=const.c_L;
%Regne ut nye variable og deriverte
rhoG=(p)/cG^2;
rhoL=(kL+p)/cL^2;
mG=rhoG*eG;%rhoG*eG;
mL=rhoL*eL;%=rhoL*eL;
wG=wG2;%mG*uG;
wL=wL2;%mL*uL;
sigma=0.5*(mG*cG^2+mL*cL^2-kL);
muG=cG^2/2*(1+(sigma+kL)/(sqrt(sigma^2+mG*cG^2*kL)));
muL=cL^2/2*(1+(sigma)/(sqrt(sigma^2+mG*cG^2*kL)));
uG=wG/mG;
uL=wL/mL;
w_hat=[wG_hat+wL_hat;wL_hat];

%% Virtual Mass - Outlet
cvm=c_virtual_mass(eG,rhoG,rhoL);
rho=mG+mL;
delta= rho^2/rhoL/rhoG*cvm;
c=mG/rho;
pp=rhoL*eG+rhoG*eL;
cp=eG*rhoL/pp;
u=(wG+wL)/rho;

Adelta=delta*[ zeros(3,4) ; (1-c)*uG*uL -c*uG*uL -(1-c)*uL u];
Mdelta=delta*[ zeros(3,4) ; (1-c)*uG    -c*uL    -(1-c)    1];
A=[0                0               1      -1           ;
   0                0               0       1           ;
   muG-uG^2         muL-uL^2        2*uG    2*(uL-uG)   ;
   eL*muG           eL*muL          0       2*uL        ];

A=inv(eye(4)+Mdelta)*(A+Adelta);
w=[mG;mL;wG+wL;wL];
[wn_hat_L,q_L,q_hat_L,Lambda_L,w_er]=numerical_boundaries(A,w,w_hat,2,1,const.dooi,const.output_injection*const.oi,0);
mG_hat_L=wn_hat_L(1);
mL_hat_L=wn_hat_L(2);
sigma_L=0.5*(mG_hat_L*cG^2+mL_hat_L*cL^2-kL);
P=sigma_L+sqrt(sigma_L^2+mG_hat_L*cG^2*kL);

er=zeros(2,1);
er(1)=(w_er(1)-w_er(2))/wG;
er(2)=(w_er(2))/wL;

mG_hat_L=mG;
mL_hat_L=mL;
sigma_L=0.5*(mG_hat_L*cG^2+mL_hat_L*cL^2-kL);
P_mod=sigma_L+sqrt(sigma_L^2+mG_hat_L*cG^2*kL);
P=P-P_mod;