function [sec_1, sec_2, sec_1_frac, sec_2_frac, sec_1_mass, sec_2_mass, leakpos, u_s,frac...
    ]=find_leak_num2(obs, er,pressure,fraction,u_g,rho_g,u_l,rho_l,leak_gas_fraction,delta_q,w_er, dt, const,use_correct_epsilon_l,real_fraction)

k_x=const.k_x;
k_u=const.k_u;

step=k_x*6.5*(w_er(1)+w_er(2));
leakpos=obs.leakpos+step;
frac=obs.frac+delta_q*0.00000000001;
u_s=-k_u*(er(1)+er(2))*dt+obs.u_s;


if leakpos>obs.x(end-4)
    leakpos=obs.x(end-4);
elseif leakpos<obs.x(7)
    leakpos=obs.x(7);
end

i=find(obs.x>=leakpos & obs.x<(leakpos+max(obs.dx)),1);
x_2=obs.x(i);
x_1=obs.x(i-1);
x_0=obs.x(i-2);
x_3=obs.x(i+1);
dpdx=(pressure(i+1)-pressure(i))/max(obs.dx);
dedx=(fraction(i+1)-fraction(i))/max(obs.dx);

p_leak=pressure(i)+(leakpos-obs.x(i))*dpdx;

epsilon_leak=fraction(i-1)*rho_g(i-1)*u_g(i-1)/(fraction(i-1)*rho_g(i-1)*u_g(i-1)+(1-fraction(i-1))*rho_l(i-1)*u_l(i-1));
if leak_gas_fraction ~= -1
    epsilon_leak=leak_gas_fraction;    
end

if(use_correct_epsilon_l==1)
   epsilon_leak=real_fraction*1.1;
end
rho_g_leak=(p_leak)/const.c_G^2;
rho_l_leak=(p_leak+const.k_l)/const.c_L^2;

p_diff=p_leak-obs.amb;

leaksize=u_s*sqrt(p_diff*(fraction(i)*rho_g_leak+(1-fraction(i))*rho_l_leak));
leaksize_g=epsilon_leak*leaksize;
leaksize_l=(1-epsilon_leak)*leaksize;
leaksize_g=max(leaksize_g,0);
leaksize_l=max(leaksize_l,0);

dl=leakpos-x_1;
Am=[(x_2-x_0)/2, (x_3-x_1)/2;
    (x_1-x_0)+2*dl-dl^2/(x_2-x_1), dl^2/(x_2-x_1)];

leak_g=inv(Am)*[100;100]*leaksize_g;
leak_l=inv(Am)*[100;100]*leaksize_l;

sec_1_frac = leak_g(1)/(leak_g(1)+leak_l(1));
sec_2_frac = leak_g(2)/(leak_g(2)+leak_l(2));
sec_1_mass = leak_g(1)+leak_l(1);
sec_2_mass = leak_g(2)+leak_l(2);
if isnan(sec_1_frac)==1
    sec_1_frac=-1;
end
if isnan(sec_2_frac)==1
    sec_2_frac=-1;
end
sec_1=i-1; sec_2=i;