interval=2;
h1=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 1, 1]);

subplot(311);
plot(t,u_g_mod_0_store,t,u_g_mod_L_store,t,u_l_mod_0_store,t,u_l_mod_L_store);
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('u_g0','u_gL','u_l0','u_lL');
ylabel('Liquid velocity [m/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;

subplot(312);
plot(t,p_mod_0_store*1e-5,t,p_mod_L_store*1e-5);
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('p_0','p_L');
ylabel('Pressure [bar]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;

subplot(313);
plot(t,epsilon_mod_0_store,t,epsilon_mod_L_store);
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('e_0','e_L');
ylabel('Fraction'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;

h2=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 1, 1]);
subplot(411);
plot(t,w_g_0_mod_store);
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Gas Inlet [kg/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(412);
plot(t,w_g_L_mod_store);
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Gas Outlet[kg/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(413);
plot(t,w_l_0_mod_store);
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Oil Inlet [kg/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(414);
plot(t,w_l_L_mod_store);
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Oil Outlet [kg/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;

print(h1,'-dpng',['Plots\Model_' num2str(Mversjon) '_boundaries']);
print(h2,'-dpng',['Plots\Model_' num2str(Mversjon) '_flows']);

%%

interval=5;

h3=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.75, 0.75]);
subplot(421);
plot(t,m_g_0_mod_store,t,m_g_0_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Gas Inlet - m_G'); xlabel('Time [min]');
ylim([0 max(m_g_0_mod_store2)*1.2]);
ylim([11.5 12]);
% xlim([0 ticks(end)]);
grid;
subplot(422);
plot(t,m_g_L_mod_store,t,m_g_L_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Gas Outlet - m_G'); xlabel('Time [min]');
ylim([0 max(m_g_L_mod_store2)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(423);
plot(t,m_l_0_mod_store,t,m_l_0_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Oil Inlet - m_L'); xlabel('Time [min]');
ylim([0 max(m_l_0_mod_store2)*1.2]);
ylim([690 700]);
% xlim([0 ticks(end)]);
grid;
subplot(424);
plot(t,m_l_L_mod_store,t,m_l_L_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Oil Outlet - m_L'); xlabel('Time [min]');
ylim([0 max(m_l_L_mod_store2)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(425);
plot(t,w_g_0_mod_store,t,w_g_0_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Gas Inlet - w_G'); xlabel('Time [min]');
ylim([0 max(w_g_0_mod_store2)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(426);
plot(t,w_g_L_mod_store,t,w_g_L_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Gas Outlet - w_G'); xlabel('Time [min]');
ylim([0 max(w_g_L_mod_store2)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(427);
plot(t,w_l_0_mod_store,t,w_l_0_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Oil Inlet - w_L'); xlabel('Time [min]');
ylim([0 max(w_l_0_mod_store2)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(428);
plot(t,w_l_L_mod_store,t,w_l_L_mod_store2,'-g');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Oil Outlet - w_L'); xlabel('Time [min]');
ylim([0 max(w_l_L_mod_store2)*1.2]);
% xlim([0 ticks(end)]);
grid;

h4=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.75, 0.75]);
subplot(421);
plot(t,u_g_mod_0_store,t,u_g_mod_0_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Velocity Inlet [m/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(422);
plot(t,u_g_mod_L_store,t,u_g_mod_L_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Velocity Outlet[m/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(423);
plot(t,u_l_mod_0_store,t,u_l_mod_0_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil Velocity Inlet [m/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(424);
plot(t,u_l_mod_L_store,t,u_l_mod_L_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil Velocity Outlet [m/s]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(425);
plot(t,p_mod_0_store,t,p_mod_0_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Pressure Inlet [bar]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(426);
plot(t,p_mod_L_store,t,p_mod_L_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Pressure Outlet[bar]'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(427);
plot(t,epsilon_mod_0_store,t,epsilon_mod_0_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Fraction Inlet []'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
subplot(428);
plot(t,epsilon_mod_L_store,t,epsilon_mod_L_store2,'-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Fraction Outlet []'); xlabel('Time [min]');
% xlim([0 ticks(end)]);
grid;
%%
print(h3,'-dpdf',['Plots\Model_difference4']);
print(h4,'-dpdf',['Plots\Model_difference_physical3']);

%%
u_l_mod_0_store2=u_l_mod_0_store;
u_l_mod_L_store2=u_l_mod_L_store;
u_g_mod_L_store2=u_g_mod_L_store;
u_g_mod_0_store2=u_g_mod_0_store;
p_mod_0_store2=p_mod_0_store;
p_mod_L_store2=p_mod_L_store;
epsilon_mod_L_store2=epsilon_mod_L_store;
epsilon_mod_0_store2=epsilon_mod_0_store;
m_g_0_mod_store2=m_g_0_mod_store;
m_g_L_mod_store2=m_g_L_mod_store;
m_l_L_mod_store2=m_l_L_mod_store;
m_l_0_mod_store2=m_l_0_mod_store;
w_l_0_mod_store2=w_l_0_mod_store;
w_l_L_mod_store2=w_l_L_mod_store;
w_g_L_mod_store2=w_g_L_mod_store;
w_g_0_mod_store2=w_g_0_mod_store;

%%
u_l_mod_0_store3=u_l_mod_0_store;
u_l_mod_L_store3=u_l_mod_L_store;
u_g_mod_L_store3=u_g_mod_L_store;
u_g_mod_0_store3=u_g_mod_0_store;
p_mod_0_store3=p_mod_0_store;
p_mod_L_store3=p_mod_L_store;
epsilon_mod_L_store3=epsilon_mod_L_store;
epsilon_mod_0_store3=epsilon_mod_0_store;
m_g_0_mod_store3=m_g_0_mod_store;
m_g_L_mod_store3=m_g_L_mod_store;
m_l_L_mod_store3=m_l_L_mod_store;
m_l_0_mod_store3=m_l_0_mod_store;
w_l_0_mod_store3=w_l_0_mod_store;
w_l_L_mod_store3=w_l_L_mod_store;
w_g_L_mod_store3=w_g_L_mod_store;
w_g_0_mod_store3=w_g_0_mod_store;

%%
interval=5;

h3=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.75, 0.75]);
subplot(421);
plot(t,m_g_0_mod_store,'k',t,m_g_0_mod_store2,'b-',t,m_g_0_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Gas Inlet - m_G'); xlabel('Time [min]');
ylim([0 max(m_g_0_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(422);
plot(t,m_g_L_mod_store,'k',t,m_g_L_mod_store2,'b-',t,m_g_L_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Gas Outlet - m_G'); xlabel('Time [min]');
ylim([0 max(m_g_L_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(423);
plot(t,m_l_0_mod_store,'k',t,m_l_0_mod_store2,'b-',t,m_l_0_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Oil Inlet - m_L'); xlabel('Time [min]');
ylim([0 max(m_l_0_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(424);
plot(t,m_l_L_mod_store,'k',t,m_l_L_mod_store2,'b-',t,m_l_L_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Mass Oil Outlet - m_L'); xlabel('Time [min]');
ylim([0 max(m_l_L_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(425);
plot(t,w_g_0_mod_store,'k',t,w_g_0_mod_store2,'b-',t,w_g_0_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Gas Inlet - w_G'); xlabel('Time [min]');
ylim([0 max(w_g_0_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(426);
plot(t,w_g_L_mod_store,'k',t,w_g_L_mod_store2,'b-',t,w_g_L_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Gas Outlet - w_G'); xlabel('Time [min]');
ylim([0 max(w_g_L_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(427);
plot(t,w_l_0_mod_store,'k',t,w_l_0_mod_store2,'b-',t,w_l_0_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Oil Inlet - w_L'); xlabel('Time [min]');
ylim([0 max(w_l_0_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(428);
plot(t,w_l_L_mod_store,'k',t,w_l_L_mod_store2,'b-',t,w_l_L_mod_store3,'g-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Flow Oil Outlet - w_L'); xlabel('Time [min]');
ylim([0 max(w_l_L_mod_store)*1.2]);
% xlim([0 ticks(end)]);
grid;

h4=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.75, .75]);
subplot(421);
plot(t,u_g_mod_0_store,'k',t,u_g_mod_0_store2,'b-',t,u_g_mod_0_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Velocity Inlet [m/s]'); xlabel('Time [min]');
ylim([0 max(u_g_mod_0_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(422);
plot(t,u_g_mod_L_store,'k',t,u_g_mod_L_store2,'b-',t,u_g_mod_L_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Velocity Outlet[m/s]'); xlabel('Time [min]');
ylim([0 max(u_g_mod_L_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(423);
plot(t,u_l_mod_0_store,'k',t,u_l_mod_0_store2,'b-',t,u_l_mod_0_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil Velocity Inlet [m/s]'); xlabel('Time [min]');
ylim([0 max(u_l_mod_0_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(424);
plot(t,u_l_mod_L_store,'k',t,u_l_mod_L_store2,'b-',t,u_l_mod_L_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil Velocity Outlet [m/s]'); xlabel('Time [min]');
ylim([0 max(u_l_mod_L_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(425);
plot(t,p_mod_0_store,'k',t,p_mod_0_store2,'b-',t,p_mod_0_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Pressure Inlet [bar]'); xlabel('Time [min]');
ylim([0 max(p_mod_0_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(426);
plot(t,p_mod_L_store,'k',t,p_mod_L_store2,'b-',t,p_mod_L_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Pressure Outlet[bar]'); xlabel('Time [min]');
ylim([0 max(p_mod_L_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(427);
plot(t,epsilon_mod_0_store,'k',t,epsilon_mod_0_store2,'b-',t,epsilon_mod_0_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Fraction Inlet []'); xlabel('Time [min]');
ylim([0 max(epsilon_mod_0_store)*1.2]);
% xlim([0 ticks(end)]);
grid;
subplot(428);
plot(t,epsilon_mod_L_store,'k',t,epsilon_mod_L_store2,'b-',t,epsilon_mod_L_store3,'g-.');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas Fraction Outlet []'); xlabel('Time [min]');
ylim([0 max(epsilon_mod_L_store)*1.2]);
% xlim([0 ticks(end)]);
grid;