close all;

interval=5;

u_t_l_surf=(u_l_mod_surf-u_l_obs_surf);
u_t_g_surf=u_g_mod_surf-u_g_obs_surf;
p_t_surf=(p_mod_surf-p_obs_surf)*1e-5;
epsilon_t_surf=(epsilon_mod_surf-epsilon_obs_surf);

orient landscape;

h2=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.6, 0.75]);
subplot(411);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_g_surf'.^2)),'k');
hold on;
xlim([0 t(end)]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - gas velocity');

subplot(412);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_l_surf'.^2))','k');
hold on;
xlim([0 t(end)]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - oil velocity');

subplot(413);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(p_t_surf'.^2)),'k');
hold on;
xlim([0 t(end)]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - pressure');

subplot(414);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(epsilon_t_surf'.^2)),'k');
hold on;
xlim([0 t(end)]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - fraction');

%% 
h3=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 1, 1]);
subplot(421);
plot(t(1:simlength),u_g_obs_0_store(1:simlength),'-',t(1:simlength),u_g_mod_0_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('uG_{obs}_0','uG_{mod}_0','location','northeast');
ylabel('Gas velocity [m/s]'); xlabel('Time [min]');
grid;

subplot(423);
plot(t(1:simlength),u_l_obs_0_store(1:simlength),'-',t(1:simlength),u_l_mod_0_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('uL_{obs}_0','uL_{mod}_0','location','northeast');
ylabel('Liquid velocity [m/s]'); xlabel('Time [min]');
grid;

subplot(422);
plot(t(1:simlength),u_g_obs_L_store(1:simlength),'-',t(1:simlength),u_g_mod_L_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('uG_{obs}_L','uG_{mod}_L','location','northeast');
ylabel('Gas velocity [m/s]'); xlabel('Time [min]');
grid;

subplot(424);
plot(t(1:simlength),u_l_obs_L_store(1:simlength),'-',t(1:simlength),u_l_mod_L_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('uL_{obs}_L','uL_{mod}_L','location','northeast');
ylabel('Liquid velocity [m/s]'); xlabel('Time [min]');
grid;

subplot(425);
plot(t(1:simlength),epsilon_obs_0_store(1:simlength),'-',t(1:simlength),epsilon_mod_0_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('epsilon_{obs}_0','epsilon_{mod}_0','location','northeast');
ylabel('Volume fraction [ ]'); xlabel('Time [min]');
grid;

subplot(426);
plot(t(1:simlength),epsilon_obs_L_store(1:simlength),'-',t(1:simlength),epsilon_mod_L_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('epsilon_{obs}_L','epsilon_{mod}_L','location','northeast');
ylabel('Volume fraction [ ]'); xlabel('Time [min]');
grid;

subplot(427);
plot(t(1:simlength),p_obs_0_store(1:simlength),'-',t(1:simlength),p_mod_0_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('p_{obs}_0','p_{mod}_0','location','northeast');
ylabel('Pressure [bar]'); xlabel('Time [min]');
grid;

subplot(428);
plot(t(1:simlength),p_obs_L_store(1:simlength),'-',t(1:simlength),p_mod_L_store(ii_select_obs),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('p_{obs}_L','p_{mod}_L','location','northeast');
ylabel('Pressure [bar]'); xlabel('Time [min]');
grid;
%%
h5=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 1, 1]);
subplot(421);
plot(t(1:simlength),m_g_0_mod_store(ii_select_obs),'k-',t(1:simlength),m_g_0_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_G - model','m_G - observer','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(423);
plot(t(1:simlength),m_l_0_mod_store(ii_select_obs),'k-',t(1:simlength),m_l_0_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_L - model','m_L - observer','location','southeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(422);
plot(t(1:simlength),m_g_L_mod_store(ii_select_obs),'k-',t(1:simlength),m_g_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_G - model','m_G - observer','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(424);
plot(t(1:simlength),m_l_L_mod_store(ii_select_obs),'k-',t(1:simlength),m_l_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('m_L - model','m_L - observer','location','northeast');
ylabel('Mass [kg/m]'); xlabel('Time [min]');
grid;

subplot(425);
plot(t(1:simlength),w_g_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_g_0_obs_store(1:simlength),'k--');
% plot(t(1:simlength),w_g_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_g_0_obs_store(1:simlength),'k--',t(1:simlength),w_g_obs_0_store_unfiltered(1:simlength),'-r');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_G - model','w_G - observer','location','southeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(426);
plot(t(1:simlength),w_g_L_mod_store(ii_select_obs),'k-',t(1:simlength),w_g_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_G - model','w_G - observer','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(427);
% plot(t(1:simlength),w_l_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_l_0_obs_store(1:simlength),'k--',t(1:simlength),w_l_obs_0_store_unfiltered(1:simlength),'-r');
plot(t(1:simlength),w_l_0_mod_store(ii_select_obs),'k-',t(1:simlength),w_l_0_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_L - model','w_L - observer','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;

subplot(428);
plot(t(1:simlength),w_l_L_mod_store(ii_select_obs),'k-',t(1:simlength),w_l_L_obs_store(1:simlength),'k--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('w_L - model','w_L - observer','location','northeast');
ylabel('Mass Flow [kg/s]'); xlabel('Time [min]');
grid;
%%

h4=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.7, 0.7]);
subplot(311);
plot(t(1:simlength),-obs_leak_g(1:simlength),'k--',t(1:simlength),-leak_mod_g(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
grid;
subplot(312);
plot(t(1:simlength),-obs_leak_l(1:simlength),'k--',t(1:simlength),-leak_mod_l(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
grid;

subplot(313);
plot(t(1:simlength),leakpos_obs_store(1:simlength),'k--',t(1:simlength),leak_pos*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
ylim([0 5000]);
grid;

pos=find(ii_select_obs==(5*60/dt))
if length(pos)>1
    for i=1:3
        for x=2:length(pos);
            subplot(3,1,i)
            hold on;
            line([pos(x)*dt,pos(x)*dt],get(gca,'YLim'),'color',[0.3 0.3 0.3],'LineStyle','--','Linewidth',1.5)
        end
    end
end

%%
h6=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 1, 1]);
subplot(421);
plot(t(1:simlength),obs_q_mod_0_store(1:simlength,1),'-',t(1:simlength),obs_q_obs_0_store(1:simlength,1),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_1 [kg/m]'); xlabel('Time [min]');
grid;

subplot(422);
plot(t(1:simlength),obs_q_mod_L_store(1:simlength,1),'-',t(1:simlength),obs_q_obs_L_store(1:simlength,1),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_1 [kg/m]'); xlabel('Time [min]');
grid;

subplot(423);
plot(t(1:simlength),obs_q_mod_0_store(1:simlength,2),'-',t(1:simlength),obs_q_obs_0_store(1:simlength,2),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_2 [kg/m]'); xlabel('Time [min]');
grid;

subplot(424);
plot(t(1:simlength),obs_q_mod_L_store(1:simlength,2),'-',t(1:simlength),obs_q_obs_L_store(1:simlength,2),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_2 [kg/m]'); xlabel('Time [min]');
grid;

subplot(425);
plot(t(1:simlength),obs_q_mod_0_store(1:simlength,3),'-',t(1:simlength),obs_q_obs_0_store(1:simlength,3),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_3 [kg/m]'); xlabel('Time [min]');
grid;

subplot(426);
plot(t(1:simlength),obs_q_mod_L_store(1:simlength,3),'-',t(1:simlength),obs_q_obs_L_store(1:simlength,3),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_3 [kg/m]'); xlabel('Time [min]');
grid;

subplot(427);
plot(t(1:simlength),obs_q_mod_0_store(1:simlength,4),'-',t(1:simlength),obs_q_obs_0_store(1:simlength,4),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_4 [kg/m]'); xlabel('Time [min]');
grid;

subplot(428);
plot(t(1:simlength),obs_q_mod_L_store(1:simlength,4),'-',t(1:simlength),obs_q_obs_L_store(1:simlength,4),'--');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('model','observer','location','southeast');
ylabel('q_4 [kg/m]'); xlabel('Time [min]');
grid;

%%
versn=1;
while exist(['Plots\Observer_' num2str(versn) '_L2.pdf'],'file')
    versn=versn+1;
end
% print(h,'-dpng',['Plots\Observer_' num2str(versn) '_error']);
% print(g,'-dpdf',['Plots\Observer_' num2str(versn) '_boundaries']);
print(h2,'-dpdf',['Plots\Observer_' num2str(versn) '_L2']);
print(h3,'-dpdf',['Plots\Observer_' num2str(versn) '_mod_vs_obs']);
print(h4,'-dpdf',['Plots\Observer_' num2str(versn) '_leak']);
print(h5,'-dpdf',['Plots\Observer_' num2str(versn) '_m_w']);
print(h6,'-dpdf',['Plots\Observer_' num2str(versn) '_q']);

return

%%
model='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250'
uten_oi='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs30_oi0_e0'
med_oi='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs32_oi0_e0'

model=['mat_files\',model];
uten_oi=['mat_files\',uten_oi];
med_oi=['mat_files\',med_oi];

load(model);
simlength=T_end/dt;
start_leak=5;
load(uten_oi);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;
load(med_oi);
interval=5;

leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_med_oi=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end))
mean_leak_l_med_oi=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end))
mean_pos_med_oi=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end))
tc_med_oi=find_tc(leak_pos, leakpos_obs_store, T_end, 250, dt, start_leak)

mean_leak_g_uten_oi=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_uten_oi=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_uten_oi=mean(leak_pos-leakpos_obs_store2(start_leak*60/dt:end))
tc_uten_oi=find_tc(leak_pos, leakpos_obs_store2, T_end, 250, dt, start_leak)


h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.75, 0.8]);
subplot(311);
plot(t(1:simlength),-obs_leak_g(1:simlength),'g--',t(1:simlength),-obs_leak_g2(1:simlength),'b--',t(1:simlength),-leak_mod_g(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('w/output injection','no output injection','model','location','southeast');
xlim([0 t(simlength)]);
grid;
subplot(312);
plot(t(1:simlength),-obs_leak_l(1:simlength),'g--',t(1:simlength),-obs_leak_l2(1:simlength),'b--',t(1:simlength),-leak_mod_l(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('w/output injection','no output injection','model','location','southeast');
xlim([0 t(simlength)]);
grid;
% subplot(413);
% plot(t(1:simlength),obs_leak_total(1:simlength),'-',t(1:simlength),leak_mod_total(1:simlength),'g');
% ticks=get(gca,'XTick');
% ticks(end)=T_end;
% tick_labels=0:interval:(ticks(end)/60);
% ticks=0:interval*60:ticks(end);
% set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
% ylabel('Total leak [m/s]'); xlabel('Time [min]');
% grid;
subplot(313);
plot(t(1:simlength),leakpos_obs_store(1:simlength),'g--',t(1:simlength),leakpos_obs_store2(1:simlength),'b--',t(1:simlength),leak_pos*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('w/output injection','no output injection','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
grid;
if length(pos)>1
    for i=1:3
        for x=2:length(pos);
            subplot(3,1,i)
            hold on;
            line([pos(x)*dt,pos(x)*dt],get(gca,'YLim'),'color',[0.3 0.3 0.3],'LineStyle','--','Linewidth',1.5)
        end
    end
end
print(h4,'-dpdf',['Plots\Model_',num2str(Mversjon),'_leak_compare']);
%% mixed
model='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250'
case1='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs33_oi0_e0'
case2='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs34_oi0_e0'
case3='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs35_oi0_e0'
case4='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs36_oi0_e0'

model=['mat_files\',model];
case1=['mat_files\',case1];
case2=['mat_files\',case2];
case3=['mat_files\',case3];
case4=['mat_files\',case4];

load(model);
ep_l=leak_mod_g(end)/(leak_mod_g(end)+leak_mod_l(end))
simlength=T_end/dt;
start_leak=5;
load(case1);
obs_leak_g1=obs_leak_g;
obs_leak_l1=obs_leak_l;
leakpos_obs_store1=leakpos_obs_store;
load(case2);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;
load(case3);
obs_leak_g3=obs_leak_g;
obs_leak_l3=obs_leak_l;
leakpos_obs_store3=leakpos_obs_store;
load(case4);
obs_leak_g4=obs_leak_g;
obs_leak_l4=obs_leak_l;
leakpos_obs_store4=leakpos_obs_store;
interval=5;

leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_1=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g1(start_leak*60/dt:end))
mean_leak_l_1=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l1(start_leak*60/dt:end))
mean_pos_1=mean(leak_pos-leakpos_obs_store1(start_leak*60/dt:end))
tc_1=find_tc(leak_pos, leakpos_obs_store1, T_end, 300, dt, start_leak)

mean_leak_g_2=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_2=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_2=mean(leak_pos-leakpos_obs_store2(start_leak*60/dt:end))
tc_2=find_tc(leak_pos, leakpos_obs_store2, T_end, 300, dt, start_leak)

mean_leak_g_3=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g3(start_leak*60/dt:end))
mean_leak_l_3=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l3(start_leak*60/dt:end))
mean_pos_3=mean(leak_pos-leakpos_obs_store3(start_leak*60/dt:end))
tc_3=find_tc(leak_pos, leakpos_obs_store3, T_end, 300, dt, start_leak)

mean_leak_g_4=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g4(start_leak*60/dt:end))
mean_leak_l_4=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l4(start_leak*60/dt:end))
mean_pos_4=mean(leak_pos-leakpos_obs_store4(start_leak*60/dt:end))
tc_4=find_tc(leak_pos, leakpos_obs_store4, T_end, 300, dt, start_leak)

h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.85, 0.95]);
subplot(311);
hold on;
plot(t(1:simlength),-obs_leak_g1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_g2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_g3(1:simlength),'--','color',[0.5 0.9 1]);
plot(t(1:simlength),-obs_leak_g4(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_g(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('0.02','0.1','0.5','0.95','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(312);
hold on;
plot(t(1:simlength),-obs_leak_l1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_l2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_l3(1:simlength),'--','color',[0.5 0.9 1]);
plot(t(1:simlength),-obs_leak_l4(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_l(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('0.02','0.1','0.5','0.95','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(313);
hold on;
plot(t(1:simlength),leakpos_obs_store1(1:simlength),'g--');
plot(t(1:simlength),leakpos_obs_store2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),leakpos_obs_store3(1:simlength),'--','color',[0.5 0.9 1]);
plot(t(1:simlength),leakpos_obs_store4(1:simlength),'b--');
plot(t(1:simlength),leak_pos*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('0.02','0.1','0.5','0.95','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;
print(h4,'-dpdf',['Plots\Model_',num2str(Mversjon),'_leak_compare']);

%% stratified
model='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650'
case1='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs42_oi0_e0'
case2='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs43_oi0_e0'
case3='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs44_oi0_e0'
case4='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs45_oi0_e0'

model=['mat_files\',model];
case1=['mat_files\',case1];
case2=['mat_files\',case2];
case3=['mat_files\',case3];
case4=['mat_files\',case4];

load(model);
ep_l=leak_mod_g(end)/(leak_mod_g(end)+leak_mod_l(end))
simlength=T_end/dt;
start_leak=5;
load(case1);
obs_leak_g1=obs_leak_g;
obs_leak_l1=obs_leak_l;
leakpos_obs_store1=leakpos_obs_store;
load(case2);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;
load(case3);
obs_leak_g3=obs_leak_g;
obs_leak_l3=obs_leak_l;
leakpos_obs_store3=leakpos_obs_store;
load(case4);
obs_leak_g4=obs_leak_g;
obs_leak_l4=obs_leak_l;
leakpos_obs_store4=leakpos_obs_store;
interval=5;

leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_1=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g1(start_leak*60/dt:end))
mean_leak_l_1=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l1(start_leak*60/dt:end))
mean_pos_1=mean(leak_pos-leakpos_obs_store1(start_leak*60/dt:end))
tc_1=find_tc(leak_pos, leakpos_obs_store1, T_end, 300, dt, start_leak)

mean_leak_g_2=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_2=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_2=mean(leak_pos-leakpos_obs_store2(start_leak*60/dt:end))
tc_2=find_tc(leak_pos, leakpos_obs_store2, T_end, 300, dt, start_leak)

mean_leak_g_3=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g3(start_leak*60/dt:end))
mean_leak_l_3=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l3(start_leak*60/dt:end))
mean_pos_3=mean(leak_pos-leakpos_obs_store3(start_leak*60/dt:end))
tc_3=find_tc(leak_pos, leakpos_obs_store3, T_end, 300, dt, start_leak)

mean_leak_g_4=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g4(start_leak*60/dt:end))
mean_leak_l_4=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l4(start_leak*60/dt:end))
mean_pos_4=mean(leak_pos-leakpos_obs_store4(start_leak*60/dt:end))
tc_4=find_tc(leak_pos, leakpos_obs_store4, T_end, 300, dt, start_leak)


h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.85, 0.95]);
subplot(311);
hold on;
plot(t(1:simlength),-obs_leak_g1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_g2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_g3(1:simlength),'--','color',[0.5 0.9 1]);
plot(t(1:simlength),-obs_leak_g4(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_g(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('0.02','0.1','0.5','0.95','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(312);
hold on;
plot(t(1:simlength),-obs_leak_l1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_l2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_l3(1:simlength),'--','color',[0.5 0.9 1]);
plot(t(1:simlength),-obs_leak_l4(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_l(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('0.02','0.1','0.5','0.95','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(313);
hold on;
plot(t(1:simlength),leakpos_obs_store1(1:simlength),'g--');
plot(t(1:simlength),leakpos_obs_store2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),leakpos_obs_store3(1:simlength),'--','color',[0.5 0.9 1]);
plot(t(1:simlength),leakpos_obs_store4(1:simlength),'b--');
plot(t(1:simlength),leak_pos*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('0.02','0.1','0.5','0.95','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;
print(h4,'-dpdf',['Plots\Model_',num2str(Mversjon),'_leak_compare']);
%% stratified Varying boundaries
model1='modeldata_v75_Date-5161849_SimLength-35_Leakpos-2250'
model2='modeldata_v74_Date-516172_SimLength-35_Leakpos-2250'
model3='modeldata_v72_Date-5161528_SimLength-35_Leakpos-2250'
obs1='modeldata_v75_Date-5161849_SimLength-35_Leakpos-2250_obs57_oi0_e0'
obs2='modeldata_v74_Date-516172_SimLength-35_Leakpos-2250_obs56_oi0_e0'
obs3='modeldata_v72_Date-5161528_SimLength-35_Leakpos-2250_obs54_oi0_e0'


model1=['mat_files\',model1];
model2=['mat_files\',model2];
model3=['mat_files\',model3];
obs1=['mat_files\',obs1];
obs2=['mat_files\',obs2];
obs3=['mat_files\',obs3];

load(model1);
w_g_0_mod_store1=w_g_0_mod_store;
w_l_0_mod_store1=w_l_0_mod_store;
leak_mod_g1=leak_mod_g;
leak_mod_l1=leak_mod_l;
leak_pos1=leak_pos;
load(model2);
w_g_0_mod_store2=w_g_0_mod_store;
w_l_0_mod_store2=w_l_0_mod_store;
leak_mod_g2=leak_mod_g;
leak_mod_l2=leak_mod_l;
leak_pos2=leak_pos;
load(model3);
w_g_0_mod_store3=w_g_0_mod_store;
w_l_0_mod_store3=w_l_0_mod_store;
leak_mod_g3=leak_mod_g;
leak_mod_l3=leak_mod_l;
leak_pos3=leak_pos;


interval=5;

h7=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.6]);
subplot 211
hold on;
plot(t(1:simlength),w_g_0_mod_store1(1:simlength),'g-');
plot(t(1:simlength),w_g_0_mod_store2(1:simlength),'-','color',[0.0 0.5 0.0]);
plot(t(1:simlength),w_g_0_mod_store3(1:simlength),'b-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('Case 1','Case 2','Case 3','location','northeast');
ylabel('Mass Flow Gas [kg/s]'); xlabel('Time [min]');
ylim([0 36]);
grid;
box on
subplot 212
hold on;
plot(t(1:simlength),w_l_0_mod_store1(1:simlength),'g-');
plot(t(1:simlength),w_l_0_mod_store2(1:simlength),'-','color',[0.0 0.5 0.0]);
plot(t(1:simlength),w_l_0_mod_store3(1:simlength),'b-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('Case 1','Case 2','Case 3','location','northeast');
ylabel('Mass Flow Oil [kg/s]'); xlabel('Time [min]');
ylim([0 650]);
grid;
box on

print(h7,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_strat']);

ep_l=leak_mod_g(end)/(leak_mod_g(end)+leak_mod_l(end))
simlength=T_end/dt;
start_leak=5;
load(obs1);
obs_leak_g1=obs_leak_g;
obs_leak_l1=obs_leak_l;
leakpos_obs_store1=leakpos_obs_store;
load(obs2);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;
load(obs3);
obs_leak_g3=obs_leak_g;
obs_leak_l3=obs_leak_l;
leakpos_obs_store3=leakpos_obs_store;



leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_1=-mean(leak_mod_g1(ii_select_obs(start_leak*60/dt:end))-obs_leak_g1(start_leak*60/dt:end))
mean_leak_l_1=-mean(leak_mod_l1(ii_select_obs(start_leak*60/dt:end))-obs_leak_l1(start_leak*60/dt:end))
mean_pos_1=mean(leak_pos1-leakpos_obs_store1(start_leak*60/dt:end))
tc_1=find_tc(leak_pos1, leakpos_obs_store1, T_end, 300, dt, start_leak)

mean_leak_g_2=-mean(leak_mod_g2(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_2=-mean(leak_mod_l2(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_2=mean(leak_pos2-leakpos_obs_store2(start_leak*60/dt:end))
tc_2=find_tc(leak_pos2, leakpos_obs_store2, T_end, 300, dt, start_leak)

mean_leak_g_3=-mean(leak_mod_g3(ii_select_obs(start_leak*60/dt:end))-obs_leak_g3(start_leak*60/dt:end))
mean_leak_l_3=-mean(leak_mod_l3(ii_select_obs(start_leak*60/dt:end))-obs_leak_l3(start_leak*60/dt:end))
mean_pos_3=mean(leak_pos3-leakpos_obs_store3(start_leak*60/dt:end))
tc_3=find_tc(leak_pos3, leakpos_obs_store3, T_end, 300, dt, start_leak)

h8=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.3]);
hold on;
plot(t(1:simlength),leakpos_obs_store1(1:simlength),'g-');
plot(t(1:simlength),leakpos_obs_store2(1:simlength),'-','color',[0.0 0.5 0.0]);
plot(t(1:simlength),leakpos_obs_store3(1:simlength),'b-');
plot(t(1:simlength),leak_pos1*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('Case1','Case2','Case3','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;

print(h8,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_strat_leak']);

h11=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.42]);
subplot(211);
hold on;
plot(t(1:simlength),-obs_leak_g1(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_g1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 1','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(212);
hold on;
plot(t(1:simlength),-obs_leak_l1(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_l1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 1','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;

h12=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.42]);
subplot(211);
hold on;
plot(t(1:simlength),-obs_leak_g2(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_g2(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 2','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(212);
hold on;
plot(t(1:simlength),-obs_leak_l2(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_l2(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 2','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;

h13=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.42]);
subplot(211);
hold on;
plot(t(1:simlength),-obs_leak_g3(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_g3(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 3','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(212);
hold on;
plot(t(1:simlength),-obs_leak_l3(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_l3(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 3','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;

print(h11,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_strat_magn1']);
print(h12,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_strat_magn2']);
print(h13,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_strat_magn3']);
%% mixed Varying boundaries
model1='modeldata_v76_Date-516205_SimLength-35_Leakpos-2250'
model2='modeldata_v71_Date-5161150_SimLength-35_Leakpos-2250'
model3='modeldata_v73_Date-516168_SimLength-35_Leakpos-2250'
obs1='modeldata_v76_Date-516205_SimLength-35_Leakpos-2250_obs58_oi0_e0'
obs2='modeldata_v71_Date-5161150_SimLength-35_Leakpos-2250_obs53_oi0_e0'
obs3='modeldata_v73_Date-516168_SimLength-35_Leakpos-2250_obs55_oi0_e0'


model1=['mat_files\',model1];
model2=['mat_files\',model2];
model3=['mat_files\',model3];
obs1=['mat_files\',obs1];
obs2=['mat_files\',obs2];
obs3=['mat_files\',obs3];

load(model1);
w_g_0_mod_store1=w_g_0_mod_store;
w_l_0_mod_store1=w_l_0_mod_store;
leak_mod_g1=leak_mod_g;
leak_mod_l1=leak_mod_l;
leak_pos1=leak_pos;
load(model2);
w_g_0_mod_store2=w_g_0_mod_store;
w_l_0_mod_store2=w_l_0_mod_store;
leak_mod_g2=leak_mod_g;
leak_mod_l2=leak_mod_l;
leak_pos2=leak_pos;
load(model3);
w_g_0_mod_store3=w_g_0_mod_store;
w_l_0_mod_store3=w_l_0_mod_store;
leak_mod_g3=leak_mod_g;
leak_mod_l3=leak_mod_l;
leak_pos3=leak_pos;


interval=5;

h7=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.6]);
subplot 211
hold on;
plot(t(1:simlength),w_g_0_mod_store1(1:simlength),'g-');
plot(t(1:simlength),w_g_0_mod_store2(1:simlength),'-','color',[0.0 0.5 0.0]);
plot(t(1:simlength),w_g_0_mod_store3(1:simlength),'b-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('Case 4','Case 5','Case 6','location','northeast');
ylabel('Mass Flow Gas [kg/s]'); xlabel('Time [min]');
ylim([0 160]);
grid;
box on
subplot 212
hold on;
plot(t(1:simlength),w_l_0_mod_store1(1:simlength),'g-');
plot(t(1:simlength),w_l_0_mod_store2(1:simlength),'-','color',[0.0 0.5 0.0]);
plot(t(1:simlength),w_l_0_mod_store3(1:simlength),'b-');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
legend('Case 4','Case 5','Case 6','location','northeast');
ylabel('Mass Flow Oil [kg/s]'); xlabel('Time [min]');
ylim([0 3000]);
grid;
box on

print(h7,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_mixed']);

ep_l=leak_mod_g(end)/(leak_mod_g(end)+leak_mod_l(end))
simlength=T_end/dt;
start_leak=5;
load(obs1);
obs_leak_g1=obs_leak_g;
obs_leak_l1=obs_leak_l;
leakpos_obs_store1=leakpos_obs_store;
load(obs2);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;
load(obs3);
obs_leak_g3=obs_leak_g;
obs_leak_l3=obs_leak_l;
leakpos_obs_store3=leakpos_obs_store;



leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_1=-mean(leak_mod_g1(ii_select_obs(start_leak*60/dt:end))-obs_leak_g1(start_leak*60/dt:end))
mean_leak_l_1=-mean(leak_mod_l1(ii_select_obs(start_leak*60/dt:end))-obs_leak_l1(start_leak*60/dt:end))
mean_pos_1=mean(leak_pos1-leakpos_obs_store1(start_leak*60/dt:end))
tc_1=find_tc(leak_pos1, leakpos_obs_store1, T_end, 300, dt, start_leak)

mean_leak_g_2=-mean(leak_mod_g2(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_2=-mean(leak_mod_l2(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_2=mean(leak_pos2-leakpos_obs_store2(start_leak*60/dt:end))
tc_2=find_tc(leak_pos2, leakpos_obs_store2, T_end, 300, dt, start_leak)

mean_leak_g_3=-mean(leak_mod_g3(ii_select_obs(start_leak*60/dt:end))-obs_leak_g3(start_leak*60/dt:end))
mean_leak_l_3=-mean(leak_mod_l3(ii_select_obs(start_leak*60/dt:end))-obs_leak_l3(start_leak*60/dt:end))
mean_pos_3=mean(leak_pos3-leakpos_obs_store3(start_leak*60/dt:end))
tc_3=find_tc(leak_pos3, leakpos_obs_store3, T_end, 300, dt, start_leak)

h8=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.3]);
hold on;
plot(t(1:simlength),leakpos_obs_store1(1:simlength),'g-');
plot(t(1:simlength),leakpos_obs_store2(1:simlength),'-','color',[0.0 0.5 0.0]);
plot(t(1:simlength),leakpos_obs_store3(1:simlength),'b-');
plot(t(1:simlength),leak_pos1*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('Case 4','Case 5','Case 6','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;
pos=find(ii_select_obs==(5*60/dt))
if length(pos)>1
    for i=1:1
        for x=2:length(pos);
            subplot(1,1,i)
            hold on;
            line([pos(x)*dt,pos(x)*dt],get(gca,'YLim'),'color',[0.3 0.3 0.3],'LineStyle','--','Linewidth',1.5)
        end
    end
end


print(h8,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_mixed_leak']);

h11=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.42]);
subplot(211);
hold on;
plot(t(1:simlength),-obs_leak_g1(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_g1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 4','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(212);
hold on;
plot(t(1:simlength),-obs_leak_l1(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_l1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 4','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;

pos=find(ii_select_obs==(5*60/dt))
if length(pos)>1
    for i=1:2
        for x=2:length(pos);
            subplot(2,1,i)
            hold on;
            line([pos(x)*dt,pos(x)*dt],get(gca,'YLim'),'color',[0.3 0.3 0.3],'LineStyle','--','Linewidth',1.5)
        end
    end
end

h12=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.42]);
subplot(211);
hold on;
plot(t(1:simlength),-obs_leak_g2(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_g2(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 5','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(212);
hold on;
plot(t(1:simlength),-obs_leak_l2(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_l2(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 5','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;

pos=find(ii_select_obs==(5*60/dt))
if length(pos)>1
    for i=1:2
        for x=2:length(pos);
            subplot(2,1,i)
            hold on;
            line([pos(x)*dt,pos(x)*dt],get(gca,'YLim'),'color',[0.3 0.3 0.3],'LineStyle','--','Linewidth',1.5)
        end
    end
end
h13=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.8, 0.42]);
subplot(211);
hold on;
plot(t(1:simlength),-obs_leak_g3(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_g3(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 6','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;
subplot(212);
hold on;
plot(t(1:simlength),-obs_leak_l3(1:simlength),'k--');
plot(t(1:simlength),-leak_mod_l3(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 6','model','location','northwest');
xlim([0 t(simlength)]);
box on;
grid;

pos=find(ii_select_obs==(5*60/dt))
if length(pos)>1
    for i=1:2
        for x=2:length(pos);
            subplot(2,1,i)
            hold on;
            line([pos(x)*dt,pos(x)*dt],get(gca,'YLim'),'color',[0.3 0.3 0.3],'LineStyle','--','Linewidth',1.5)
        end
    end
end
print(h11,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_mixed_magn1']);
print(h12,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_mixed_magn2']);
print(h13,'-dpdf',['Plots\Varying_bounds_',num2str(Mversjon),'_mixed_magn3']);
%% bias strat boundaries
model1='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650'
model2='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650'
model3='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650'
obs1='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs66_oi0_e0'
obs2='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs67_oi0_e0'
obs3='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs68_oi0_e0'


model1=['mat_files\',model1];
model2=['mat_files\',model2];
model3=['mat_files\',model3];
obs1=['mat_files\',obs1];
obs2=['mat_files\',obs2];
obs3=['mat_files\',obs3];

load(model1);
w_g_0_mod_store1=w_g_0_mod_store;
w_l_0_mod_store1=w_l_0_mod_store;
leak_mod_g1=leak_mod_g;
leak_mod_l1=leak_mod_l;
leak_pos1=leak_pos;
load(model2);
w_g_0_mod_store2=w_g_0_mod_store;
w_l_0_mod_store2=w_l_0_mod_store;
leak_mod_g2=leak_mod_g;
leak_mod_l2=leak_mod_l;
leak_pos2=leak_pos;
load(model3);
w_g_0_mod_store3=w_g_0_mod_store;
w_l_0_mod_store3=w_l_0_mod_store;
leak_mod_g3=leak_mod_g;
leak_mod_l3=leak_mod_l;
leak_pos3=leak_pos;


interval=5;

ep_l=leak_mod_g(end)/(leak_mod_g(end)+leak_mod_l(end))
simlength=T_end/dt;
start_leak=5;
load(obs1);
obs_leak_g1=obs_leak_g;
obs_leak_l1=obs_leak_l;
leakpos_obs_store1=leakpos_obs_store;
load(obs2);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;
load(obs3);
obs_leak_g3=obs_leak_g;
obs_leak_l3=obs_leak_l;
leakpos_obs_store3=leakpos_obs_store;


ii_select_obs=ii_select_obs;
leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_1=-mean(leak_mod_g1(ii_select_obs(start_leak*60/dt:end))-obs_leak_g1(start_leak*60/dt:end))
mean_leak_l_1=-mean(leak_mod_l1(ii_select_obs(start_leak*60/dt:end))-obs_leak_l1(start_leak*60/dt:end))
mean_pos_1=mean(leak_pos1-leakpos_obs_store1(start_leak*60/dt:end))
tc_1=find_tc(leak_pos1, leakpos_obs_store1, T_end, 300, dt, start_leak)

mean_leak_g_2=-mean(leak_mod_g2(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_2=-mean(leak_mod_l2(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_2=mean(leak_pos2-leakpos_obs_store2(start_leak*60/dt:end))
tc_2=find_tc(leak_pos2, leakpos_obs_store2, T_end, 300, dt, start_leak)

mean_leak_g_3=-mean(leak_mod_g3(ii_select_obs(start_leak*60/dt:end))-obs_leak_g3(start_leak*60/dt:end))
mean_leak_l_3=-mean(leak_mod_l3(ii_select_obs(start_leak*60/dt:end))-obs_leak_l3(start_leak*60/dt:end))
mean_pos_3=mean(leak_pos3-leakpos_obs_store3(start_leak*60/dt:end))
tc_3=find_tc(leak_pos3, leakpos_obs_store3, T_end, 300, dt, start_leak)


h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.85, 0.95]);
subplot(311);
hold on;
plot(t(1:simlength),-obs_leak_g1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_g2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_g3(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_g1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('w','p','w+p','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(312);
hold on;
plot(t(1:simlength),-obs_leak_l1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_l2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_l3(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_l1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('w','p','w+p','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(313);
hold on;
plot(t(1:simlength),leakpos_obs_store1(1:simlength),'g--');
plot(t(1:simlength),leakpos_obs_store2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),leakpos_obs_store3(1:simlength),'b--');
plot(t(1:simlength),leak_pos1*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('w','p','w+p','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;
print(h4,'-dpdf',['Plots\Model_',num2str(Mversjon),'_bias_strat']);
%% bias mixed boundaries
model1='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250'
model2='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250'
model3='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250'
obs1='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs69_oi0_e0'
obs2='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs70_oi0_e0'
obs3='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs71_oi0_e0'


model1=['mat_files\',model1];
model2=['mat_files\',model2];
model3=['mat_files\',model3];
obs1=['mat_files\',obs1];
obs2=['mat_files\',obs2];
obs3=['mat_files\',obs3];

load(model1);
w_g_0_mod_store1=w_g_0_mod_store;
w_l_0_mod_store1=w_l_0_mod_store;
leak_mod_g1=leak_mod_g;
leak_mod_l1=leak_mod_l;
leak_pos1=leak_pos;
load(model2);
w_g_0_mod_store2=w_g_0_mod_store;
w_l_0_mod_store2=w_l_0_mod_store;
leak_mod_g2=leak_mod_g;
leak_mod_l2=leak_mod_l;
leak_pos2=leak_pos;
load(model3);
w_g_0_mod_store3=w_g_0_mod_store;
w_l_0_mod_store3=w_l_0_mod_store;
leak_mod_g3=leak_mod_g;
leak_mod_l3=leak_mod_l;
leak_pos3=leak_pos;


interval=5;

ep_l=leak_mod_g(end)/(leak_mod_g(end)+leak_mod_l(end))
simlength=T_end/dt;
start_leak=5;
load(obs1);
obs_leak_g1=obs_leak_g;
obs_leak_l1=obs_leak_l;
leakpos_obs_store1=leakpos_obs_store;
load(obs2);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;
load(obs3);
obs_leak_g3=obs_leak_g;
obs_leak_l3=obs_leak_l;
leakpos_obs_store3=leakpos_obs_store;


ii_select_obs=ii_select_obs;
leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_1=-mean(leak_mod_g1(ii_select_obs(start_leak*60/dt:end))-obs_leak_g1(start_leak*60/dt:end))
mean_leak_l_1=-mean(leak_mod_l1(ii_select_obs(start_leak*60/dt:end))-obs_leak_l1(start_leak*60/dt:end))
mean_pos_1=mean(leak_pos1-leakpos_obs_store1(start_leak*60/dt:end))
tc_1=find_tc(leak_pos1, leakpos_obs_store1, T_end, 300, dt, start_leak)

mean_leak_g_2=-mean(leak_mod_g2(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_2=-mean(leak_mod_l2(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_2=mean(leak_pos2-leakpos_obs_store2(start_leak*60/dt:end))
tc_2=find_tc(leak_pos2, leakpos_obs_store2, T_end, 300, dt, start_leak)

mean_leak_g_3=-mean(leak_mod_g3(ii_select_obs(start_leak*60/dt:end))-obs_leak_g3(start_leak*60/dt:end))
mean_leak_l_3=-mean(leak_mod_l3(ii_select_obs(start_leak*60/dt:end))-obs_leak_l3(start_leak*60/dt:end))
mean_pos_3=mean(leak_pos3-leakpos_obs_store3(start_leak*60/dt:end))
tc_3=find_tc(leak_pos3, leakpos_obs_store3, T_end, 300, dt, start_leak)


h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.85, 0.95]);
subplot(311);
hold on;
plot(t(1:simlength),-obs_leak_g1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_g2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_g3(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_g1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('w','p','w+p','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(312);
hold on;
plot(t(1:simlength),-obs_leak_l1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_l2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),-obs_leak_l3(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_l1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('w','p','w+p','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(313);
hold on;
plot(t(1:simlength),leakpos_obs_store1(1:simlength),'g--');
plot(t(1:simlength),leakpos_obs_store2(1:simlength),'--','color',[0.0 0.5 0.0]);
plot(t(1:simlength),leakpos_obs_store3(1:simlength),'b--');
plot(t(1:simlength),leak_pos1*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('w','p','w+p','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;
print(h4,'-dpdf',['Plots\Model_',num2str(Mversjon),'_bias_mixed']);
%%
%% bias strat boundaries
model='mat_files\modeldata_v68_Date-515158_SimLength-35_Leakpos-2250'
obs1='mat_files\modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs137'
obs2='mat_files\modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs143'

interval=5;

ep_l=leak_mod_g(end)/(leak_mod_g(end)+leak_mod_l(end))
simlength=T_end/dt;
start_leak=5;
load(obs1);
obs_leak_g1=obs_leak_g;
obs_leak_l1=obs_leak_l;
leakpos_obs_store1=leakpos_obs_store;
load(obs2);
obs_leak_g2=obs_leak_g;
obs_leak_l2=obs_leak_l;
leakpos_obs_store2=leakpos_obs_store;


ii_select_obs=ii_select_obs;
leak_percent=round(10000*-min(leak_mod_g)/mean(w_g_0_mod_store*Area))/100;

mean_leak_g_1=-mean(leak_mod_g1(ii_select_obs(start_leak*60/dt:end))-obs_leak_g1(start_leak*60/dt:end))
mean_leak_l_1=-mean(leak_mod_l1(ii_select_obs(start_leak*60/dt:end))-obs_leak_l1(start_leak*60/dt:end))
mean_pos_1=mean(leak_pos1-leakpos_obs_store1(start_leak*60/dt:end))
tc_1=find_tc(leak_pos1, leakpos_obs_store1, T_end, 300, dt, start_leak)

mean_leak_g_2=-mean(leak_mod_g2(ii_select_obs(start_leak*60/dt:end))-obs_leak_g2(start_leak*60/dt:end))
mean_leak_l_2=-mean(leak_mod_l2(ii_select_obs(start_leak*60/dt:end))-obs_leak_l2(start_leak*60/dt:end))
mean_pos_2=mean(leak_pos2-leakpos_obs_store2(start_leak*60/dt:end))
tc_2=find_tc(leak_pos2, leakpos_obs_store2, T_end, 300, dt, start_leak)

h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.85, 0.95]);
subplot(311);
hold on;
plot(t(1:simlength),-obs_leak_g1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_g2(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_g1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('-0.02 bar','+0.02 bar','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(312);
hold on;
plot(t(1:simlength),-obs_leak_l1(1:simlength),'g--');
plot(t(1:simlength),-obs_leak_l2(1:simlength),'b--');
plot(t(1:simlength),-leak_mod_l1(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('-0.02 bar','+0.02 bar','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(313);
hold on;
plot(t(1:simlength),leakpos_obs_store1(1:simlength),'g--');
plot(t(1:simlength),leakpos_obs_store2(1:simlength),'b--');
plot(t(1:simlength),leak_pos1*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('-0.02 bar','+0.02 bar','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;
print(h4,'-dpdf',['Plots\Model_bias_mixed_test']);