% Run model
clear all;
u_g_in=1;
u_l_in=1;

minutes_to_leak=105;
minutes_to_simulate=100;
run_basic_model_twophase


%Run observers
in3=1; % 5% error in pressure on=1
ob=cell(1,3);
start_leak_adaption=105;
error=0.5;


in=1;
in2=0;
run_basic_observer_twophase2
ob{1,3}=obs_string
in2=1;
run_basic_observer_twophase2
ob{1,2}=obs_string
in=0;
run_basic_observer_twophase2
ob{1,1}=obs_string

save L2comp2 ob model_string

%% PRINT
load L2comp2

interval=5;

load(model_string)
load(ob{1,3})

u_t_l_surf=(u_l_mod_surf-u_l_obs_surf);
u_t_g_surf=u_g_mod_surf-u_g_obs_surf;
p_t_surf=(p_mod_surf-p_obs_surf)*1e-5;
epsilon_t_surf=(epsilon_mod_surf-epsilon_obs_surf);

u_t_g_surf_moib=u_t_g_surf;
u_t_l_surf_moib=u_t_l_surf;
p_t_surf_moib=p_t_surf;
epsilon_t_surf_moib=epsilon_t_surf;

load(ob{1,2})

u_t_l_surf=(u_l_mod_surf-u_l_obs_surf);
u_t_g_surf=u_g_mod_surf-u_g_obs_surf;
p_t_surf=(p_mod_surf-p_obs_surf)*1e-5;
epsilon_t_surf=(epsilon_mod_surf-epsilon_obs_surf);

u_t_g_surf_moi=u_t_g_surf;
u_t_l_surf_moi=u_t_l_surf;
p_t_surf_moi=p_t_surf;
epsilon_t_surf_moi=epsilon_t_surf;

load(ob{1,1})

u_t_l_surf=(u_l_mod_surf-u_l_obs_surf);
u_t_g_surf=u_g_mod_surf-u_g_obs_surf;
p_t_surf=(p_mod_surf-p_obs_surf)*1e-5;
epsilon_t_surf=(epsilon_mod_surf-epsilon_obs_surf);

orient landscape;

h2=figure('PaperUnits','normalized','PaperType','A4','PaperPosition',[0, 0, 0.6, 0.75]);
subplot(411);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_g_surf'.^2)),'k');
hold on;
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_g_surf_moi'.^2)),'g--');
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_g_surf_moib'.^2)),'b--');
legend('Without output injection','O.I at inlet','With O.I. at both ends');
xlim([0 t(end)]);
% ylim([0 2]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - gas velocity');

subplot(412);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_l_surf'.^2))','k');
hold on;
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_l_surf_moi'.^2)),'g--');
plot([0;t(1:samp_time/dt:end)],sqrt(sum(u_t_l_surf_moib'.^2)),'b--');
legend('Without output injection','O.I at inlet','With O.I. at both ends');
xlim([0 t(end)]);
% ylim([0 2]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - oil velocity');

subplot(413);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(p_t_surf'.^2)),'k');
hold on;
plot([0;t(1:samp_time/dt:end)],sqrt(sum(p_t_surf_moi'.^2)),'g--');
plot([0;t(1:samp_time/dt:end)],sqrt(sum(p_t_surf_moib'.^2)),'b--');
legend('Without output injection','O.I at inlet','With O.I. at both ends');
xlim([0 t(end)]);
% ylim([0 2]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - pressure');

subplot(414);
plot([0;t(1:samp_time/dt:end)],sqrt(sum(epsilon_t_surf'.^2)),'k');
hold on;
plot([0;t(1:samp_time/dt:end)],sqrt(sum(epsilon_t_surf_moi'.^2)),'g--');
plot([0;t(1:samp_time/dt:end)],sqrt(sum(epsilon_t_surf_moib'.^2)),'b--');
legend('Without output injection','O.I at inlet','With O.I. at both ends');
xlim([0 t(end)]);
grid;
xlabel('Time [sec]');
ylabel('L_2 observer error - fraction');

