model_string='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250';
model_string=['mat_files\',model_string];
save last model_string

% bias=[-0.01 -0.005 0 0.005 0.01]
bias=[-0.05 0 0.05];
pbias=[-20000 0 20000];
epsilon_bias=[-0.05 0 0.05];

in=1;
in2=0;
start_leak=5;

ob_stor=cell(length(bias));
mean_leak_g=cell(length(bias));
mean_leak_l=cell(length(bias));
mean_pos=cell(length(bias));
tc=cell(length(bias));
epsilon_err=0;
p_err=0;
k_g_bias=1;
k_l_bias=1;
for w_g_err=bias
    for w_l_err=bias
        run_basic_observer_twophase2
        ii_select_obs=ii_select_obs;
        ob_stor{k_g_bias,k_l_bias}=obs_string;
        mean_leak_g{k_g_bias,k_l_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l{k_g_bias,k_l_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos{k_g_bias,k_l_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc{k_g_bias,k_l_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        k_l_bias=k_l_bias+1
    end
    k_g_bias=k_g_bias+1;
    k_l_bias=1;
end

save bias_mixed ob_stor mean_leak_g mean_leak_l mean_pos tc

ob_stor_2=cell(length(pbias));
mean_leak_g_2=cell(length(pbias));
mean_leak_l_2=cell(length(pbias));
mean_pos_2=cell(length(pbias));
tc_2=cell(length(pbias));
w_g_err=0;
w_l_err=0;
k_p_bias=1;
k_epsilon_bias=1;
for p_err=pbias
    for epsilon_err=epsilon_bias
        run_basic_observer_twophase2
        ii_select_obs=ii_select_obs;
        ob_stor_2{k_p_bias,k_epsilon_bias}=obs_string;
        mean_leak_g_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos_2{k_p_bias,k_epsilon_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc_2{k_p_bias,k_epsilon_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        k_epsilon_bias=k_epsilon_bias+1
    end
    k_p_bias=k_p_bias+1;
    k_epsilon_bias=1;
end

save bias_mixed_2 ob_stor_2 mean_leak_g_2 mean_leak_l_2 mean_pos_2 tc_2

%% plot

select=[1,1;
 1,2;
 2,1;
 2,2];

color=cell(5,1);
color{1,1}=[0 0.5 0];
color{2,1}=[0 1 0];
color{3,1}=[0.5 0.5 0];
color{4,1}=[0.5 0 0];
color{5,1}=[1 0 0];

h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.85, 0.95]);

for(i=1:length(select))
j1=select(i,1);
j2=select(i,2);
load([ob_stor{j1,j2}]);

    subplot(311);
    hold on;
    plot(t(1:simlength),-obs_leak_g(1:simlength),'--','color',color{i,1});
    subplot(312);
    hold on;
    plot(t(1:simlength),-obs_leak_l(1:simlength),'--','color',color{i,1});
    subplot(313);
    hold on;
    plot(t(1:simlength),leakpos_obs_store(1:simlength),'--','color',color{i,1});
    
end
subplot(311);
hold on;
plot(t(1:simlength),-leak_mod_g(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 1','Case 2','Case 3','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(312);
hold on;
plot(t(1:simlength),-leak_mod_l(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 1','Case 2','Case 3','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(313);
hold on;
plot(t(1:simlength),leak_pos*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('Case 1','Case 2','Case 3','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;

print(h4,'-dpdf',['Plots\Model_',num2str(Mversjon),'_bias_compare']);
%%
model_string='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650';
model_string=['mat_files\',model_string];
save last model_string

% bias=[-0.01 -0.005 0 0.005 0.01]
bias=[-0.05 0 0.05];
pbias=[-20000 0 20000];
epsilon_bias=[-0.05 0 0.05];

in=1;
in2=0;
start_leak=5;

ob_stor=cell(length(bias));
mean_leak_g=cell(length(bias));
mean_leak_l=cell(length(bias));
mean_pos=cell(length(bias));
tc=cell(length(bias));
epsilon_err=0;
p_err=0;
k_g_bias=1;
k_l_bias=1;
for w_g_err=bias
    for w_l_err=bias
        run_basic_observer_twophase2
        ii_select_obs=ii_select_obs;
        ob_stor{k_g_bias,k_l_bias}=obs_string;
        mean_leak_g{k_g_bias,k_l_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l{k_g_bias,k_l_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos{k_g_bias,k_l_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc{k_g_bias,k_l_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        k_l_bias=k_l_bias+1
    end
    k_g_bias=k_g_bias+1;
    k_l_bias=1;
end

ob_stor_2=cell(length(pbias));
mean_leak_g_2=cell(length(pbias));
mean_leak_l_2=cell(length(pbias));
mean_pos_2=cell(length(pbias));
tc_2=cell(length(pbias));
w_g_err=0;
w_l_err=0;
k_p_bias=1;
k_epsilon_bias=1;
for p_err=pbias
    for epsilon_err=epsilon_bias
        run_basic_observer_twophase2
        ii_select_obs=ii_select_obs;
        ob_stor_2{k_p_bias,k_epsilon_bias}=obs_string;
        mean_leak_g_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos_2{k_p_bias,k_epsilon_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc_2{k_p_bias,k_epsilon_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        k_epsilon_bias=k_epsilon_bias+1
    end
    k_p_bias=k_p_bias+1;
    k_epsilon_bias=1;
end

%% plot

select=[1,1;
 1,2;
 2,1;
 2,2];

color=cell(5,1);
color{1,1}=[0 0.5 0];
color{2,1}=[0 1 0];
color{3,1}=[0.5 0.5 0];
color{4,1}=[0.5 0 0];
color{5,1}=[1 0 0];

h4=figure('PaperUnits','normalized','PaperType','A5','PaperPosition',[0, 0, 0.85, 0.95]);

for(i=1:length(select))
j1=select(i,1);
j2=select(i,2);
load([ob_stor{j1,j2}]);

    subplot(311);
    hold on;
    plot(t(1:simlength),-obs_leak_g(1:simlength),'--','color',color{i,1});
    subplot(312);
    hold on;
    plot(t(1:simlength),-obs_leak_l(1:simlength),'--','color',color{i,1});
    subplot(313);
    hold on;
    plot(t(1:simlength),leakpos_obs_store(1:simlength),'--','color',color{i,1});
    
end
subplot(311);
hold on;
plot(t(1:simlength),-leak_mod_g(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Gas leakage [kg/s]'); xlabel('Time [min]');
legend('Case 1','Case 2','Case 3','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(312);
hold on;
plot(t(1:simlength),-leak_mod_l(ii_select_obs),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Oil leakage [kg/s]'); xlabel('Time [min]');
legend('Case 1','Case 2','Case 3','model','location','northeast');
xlim([0 t(simlength)]);
box on;
grid;
subplot(313);
hold on;
plot(t(1:simlength),leak_pos*ones(size(t(1:simlength))),'k');
ticks=get(gca,'XTick');
ticks(end)=T_end;
tick_labels=0:interval:(ticks(end)/60);
ticks=0:interval*60:ticks(end);
set(gca,'XTick',ticks); set(gca,'XTickLabel',tick_labels);
ylabel('Leak position [m]'); xlabel('Time [min]');
legend('Case 1','Case 2','Case 3','model','location','northeast');
ylim([0 5000]);
xlim([0 t(simlength)]);
box on;
grid;

print(h4,'-dpdf',['Plots\Model_',num2str(Mversjon),'_bias_compare']);

return

%% repeat mixed
% delete bias.out
diary bias.out
'-----------MIXED BIAS TEST-----------'
model_string='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250';
model_string=['mat_files\',model_string];
load(model_string);
obs_string1='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs';
obs_string1=['mat_files\',obs_string1];
first_number=127;

bias=[-0.05 0 0.05];
pbias=[-20000 0 20000];
epsilon_bias=[-0.05 0 0.05];


ob_stor=cell(length(bias));
mean_leak_g=cell(length(bias));
mean_leak_l=cell(length(bias));
mean_pos=cell(length(bias));
tc=cell(length(bias));
epsilon_err=0;
p_err=0;
k_g_bias=1;
k_l_bias=1;
for w_g_err=bias
    for w_l_err=bias
        obs_string1='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs';
        obs_string1=['mat_files\',obs_string1];
        load([obs_string1,num2str(first_number)]);
        first_number=first_number+1;
        ii_select_obs=ii_select_obs;
        ob_stor{k_g_bias,k_l_bias}=obs_string;
        mean_leak_g{k_g_bias,k_l_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l{k_g_bias,k_l_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos{k_g_bias,k_l_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc{k_g_bias,k_l_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        disp('----------------------------------------')
        disp(['Case: w_g_error= ',num2str(w_g_err),'  w_l_error= ',num2str(w_l_err)])
        disp(['mean_leak_g= ',num2str(mean_leak_g{k_g_bias,k_l_bias}),'  mean_leak_l= ',num2str(mean_leak_l{k_g_bias,k_l_bias})])
        disp(['mean_pos= ',num2str(mean_pos{k_g_bias,k_l_bias}),'  tc= ',num2str(tc{k_g_bias,k_l_bias})])
        k_l_bias=k_l_bias+1;
    end
    k_g_bias=k_g_bias+1;
    k_l_bias=1;
end

save bias_mixed ob_stor mean_leak_g mean_leak_l mean_pos tc

ob_stor_2=cell(length(pbias));
mean_leak_g_2=cell(length(pbias));
mean_leak_l_2=cell(length(pbias));
mean_pos_2=cell(length(pbias));
tc_2=cell(length(pbias));
w_g_err=0;
w_l_err=0;
k_p_bias=1;
k_epsilon_bias=1;
for p_err=pbias
    for epsilon_err=epsilon_bias
        obs_string1='modeldata_v68_Date-515158_SimLength-35_Leakpos-2250_obs';
        obs_string1=['mat_files\',obs_string1];
        load([obs_string1,num2str(first_number)]);
        first_number=first_number+1;
        ii_select_obs=ii_select_obs;
        ob_stor_2{k_p_bias,k_epsilon_bias}=obs_string;
        mean_leak_g_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos_2{k_p_bias,k_epsilon_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc_2{k_p_bias,k_epsilon_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        disp('----------------------------------------')
        disp(['Case: p_err= ',num2str(p_err),'  epsilon_err= ',num2str(epsilon_err)])
        disp(['mean_leak_g= ',num2str(mean_leak_g_2{k_p_bias,k_epsilon_bias}),'  mean_leak_l= ',num2str(mean_leak_l_2{k_p_bias,k_epsilon_bias})])
        disp(['mean_pos= ',num2str(mean_pos_2{k_p_bias,k_epsilon_bias}),'  tc= ',num2str(tc_2{k_p_bias,k_epsilon_bias})])
        k_epsilon_bias=k_epsilon_bias+1;
    end
    k_p_bias=k_p_bias+1;
    k_epsilon_bias=1;
end

save bias_mixed_2 ob_stor_2 mean_leak_g_2 mean_leak_l_2 mean_pos_2 tc_2

% repeat strat
'-----------STRATIFIED BIAS TEST-----------'
model_string='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650';
model_string=['mat_files\',model_string];
load(model_string);
obs_string1='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs';
obs_string1=['mat_files\',obs_string1];
first_number=145;

bias=[-0.05 0 0.05];
pbias=[-20000 0 20000];
epsilon_bias=[-0.05 0 0.05];

ob_stor=cell(length(bias));
mean_leak_g=cell(length(bias));
mean_leak_l=cell(length(bias));
mean_pos=cell(length(bias));
tc=cell(length(bias));
epsilon_err=0;
p_err=0;
k_g_bias=1;
k_l_bias=1;
for w_g_err=bias
    for w_l_err=bias
        obs_string1='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs';
        obs_string1=['mat_files\',obs_string1];
        load([obs_string1,num2str(first_number)]);
        first_number=first_number+1;
        ii_select_obs=ii_select_obs;
        ob_stor{k_g_bias,k_l_bias}=obs_string;
        mean_leak_g{k_g_bias,k_l_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l{k_g_bias,k_l_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos{k_g_bias,k_l_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc{k_g_bias,k_l_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        disp('----------------------------------------')
        disp(['Case: w_g_error= ',num2str(w_g_err),'  w_l_error= ',num2str(w_l_err)])
        disp(['mean_leak_g= ',num2str(mean_leak_g{k_g_bias,k_l_bias}),'  mean_leak_l= ',num2str(mean_leak_l{k_g_bias,k_l_bias})])
        disp(['mean_pos= ',num2str(mean_pos{k_g_bias,k_l_bias}),'  tc= ',num2str(tc{k_g_bias,k_l_bias})])
        k_l_bias=k_l_bias+1;
    end
    k_g_bias=k_g_bias+1;
    k_l_bias=1;
end

save bias_strat ob_stor mean_leak_g mean_leak_l mean_pos tc

ob_stor_2=cell(length(pbias));
mean_leak_g_2=cell(length(pbias));
mean_leak_l_2=cell(length(pbias));
mean_pos_2=cell(length(pbias));
tc_2=cell(length(pbias));
w_g_err=0;
w_l_err=0;
k_p_bias=1;
k_epsilon_bias=1;
for p_err=pbias
    for epsilon_err=epsilon_bias
        obs_string1='modeldata_v66_Date-515918_SimLength-30_Leakpos-1650_obs';
        obs_string1=['mat_files\',obs_string1];
        load([obs_string1,num2str(first_number)]);
        first_number=first_number+1;
        ii_select_obs=ii_select_obs;
        ob_stor_2{k_p_bias,k_epsilon_bias}=obs_string;
        mean_leak_g_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l_2{k_p_bias,k_epsilon_bias}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos_2{k_p_bias,k_epsilon_bias}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc_2{k_p_bias,k_epsilon_bias}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        disp('----------------------------------------')
        disp(['Case: p_err= ',num2str(p_err),'  epsilon_err= ',num2str(epsilon_err)])
        disp(['mean_leak_g= ',num2str(mean_leak_g_2{k_p_bias,k_epsilon_bias}),'  mean_leak_l= ',num2str(mean_leak_l_2{k_p_bias,k_epsilon_bias})])
        disp(['mean_pos= ',num2str(mean_pos_2{k_p_bias,k_epsilon_bias}),'  tc= ',num2str(tc_2{k_p_bias,k_epsilon_bias})])
        k_epsilon_bias=k_epsilon_bias+1;
    end
    k_p_bias=k_p_bias+1;
    k_epsilon_bias=1;
end

save bias_strat_2 ob_stor_2 mean_leak_g_2 mean_leak_l_2 mean_pos_2 tc_2
diary off