clear all;
use_correct_epsilon_l=0;
leak_size_vector=[0.15];
models=4;
mo_comp=cell(models,length(leak_size_vector));
ob_comp=cell(models,length(leak_size_vector));
for i_model=1:models
    var_model=['OLGA_filer\model_twophase_',num2str(i_model),'5.geninp']
    for i_leak=1:length(leak_size_vector)
        leak_magnitude=leak_size_vector(i_leak);
        lsegment=i_model*10+5;
        run_basic_model_twophase
        mo_comp{i_model,i_leak}=model_string;
        pause(10);
        run_basic_observer_twophase2
        ob_comp{i_model,i_leak}=obs_string;
    end
end
save comp6 mo_comp ob_comp


%% test
load comp6 mo_comp ob_comp
models=4;
mean_leak_g=cell(models,length(leak_size_vector));
mean_leak_l=cell(models,length(leak_size_vector));
mean_pos=cell(models,length(leak_size_vector));
l_pos=cell(models,length(leak_size_vector));
l_mag_g=cell(models,length(leak_size_vector));
l_mag_l=cell(models,length(leak_size_vector));
tc=cell(models,length(leak_size_vector));
start_leak=5;

for i_model=1:models
    for i_leak=1:length(leak_size_vector)
%         if i_model==4 && i_leak==4
%         else
        load(mo_comp{i_model,i_leak});
        load(ob_comp{i_model,i_leak});
        ii_select_obs=ii_select_obs;
        mean_leak_g{i_model,i_leak}=-mean(leak_mod_g(ii_select_obs(start_leak*60/dt:end))-obs_leak_g(start_leak*60/dt:end));
        mean_leak_l{i_model,i_leak}=-mean(leak_mod_l(ii_select_obs(start_leak*60/dt:end))-obs_leak_l(start_leak*60/dt:end));
        mean_pos{i_model,i_leak}=mean(leak_pos-leakpos_obs_store(start_leak*60/dt:end));
        tc{i_model,i_leak}=find_tc(leak_pos, leakpos_obs_store, T_end, 300, dt, start_leak);
        l_pos{i_model,i_leak}=leak_pos;
        l_mag_g{i_model,i_leak}=-leak_mod_g(end)/w_g_0_mod_store(end)/Area*100;
        l_mag_l{i_model,i_leak}=-leak_mod_l(end)/w_l_0_mod_store(end)/Area*100;
        
%         end
    end
end
delete comp.out
diary comp.out


disp(['\begin{table}[htbp]']);
disp(['\centering']);
disp(['\caption{Summary of leak adaption with different leak parameters.}']);
print_line=['\begin{tabular}{|c|c||'];
    for i_print=1:models
        print_line=([print_line,'c|']);
    end
print_line=([print_line,'}']);
disp(print_line);
disp(['		\hline']);
disp(['\multicolumn{2}{|c||}{}& \multicolumn{',num2str(models),'}{|c|}{Stratified Flow}\\']);
disp(['		\hline']);
disp(['\multirow{2}{*}{\minitab[c]{Leak\\size}} & & \multicolumn{',num2str(models),'}{|c|}{Leak position}\\']);

print_line=['& Measure '];
    for i_print=1:models
        print_line=([print_line,'&',num2str(l_pos{i_print,1}),'m ']);
    end
print_line=([print_line,'\\']);
disp(print_line);

disp(['		\hline']);
disp(['		\hline']);
for i_leak=1:length(leak_size_vector)
    disp(['\multirow{4}{*}{\parbox{20mm}{$f_G\approx',num2str(l_mag_g{1,i_leak},2),'\%$\\$f_L\approx',num2str(l_mag_l{1,i_leak},2),'\%$}}']);
    %tc
    print_line=['&\emph{$t_c$}[min] '];
        for i_print=1:models
            print_line=([print_line,'&',num2str(tc{i_print,i_leak},3),' ']);
        end
    print_line=([print_line,'\\']);
    disp(print_line);
    %x_l
    print_line=['&\emph{$\bar{x}_l$}[m] '];
        for i_print=1:models
            print_line=([print_line,'&',num2str(mean_pos{i_print,i_leak},3),' ']);
        end
    print_line=([print_line,'\\']);
    disp(print_line);
    %f_g
    print_line=['&\emph{$\bar{f}_G$}[kg/s] '];
        for i_print=1:models
            print_line=([print_line,'&',num2str(mean_leak_g{i_print,i_leak},3),' ']);
        end
    print_line=([print_line,'\\']);
    disp(print_line);
    %f_l
    print_line=['&\emph{$\bar{f}_L$}[kg/s] '];
        for i_print=1:models
            print_line=([print_line,'&',num2str(mean_leak_l{i_print,i_leak},3),' ']);
        end
    print_line=([print_line,'\\']);
    disp(print_line);
    disp(['		\hline']);
end
disp(['\end{tabular}']);
disp(['\label{tab:leak_bias_small_w}']);
disp(['\end{table}']);
diary off;